HDU 1072 Nightmare

来源:互联网 发布:在淘宝上怎么退换货 编辑:程序博客网 时间:2024/06/01 11:56

Nightmare

                                                            Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
                                                                                       Total Submission(s): 8741    Accepted Submission(s): 4204


Problem Description
Ignatius had a nightmare last night. He found himself in a labyrinth with a time bomb on him. The labyrinth has an exit, Ignatius should get out of the labyrinth before the bomb explodes. The initial exploding time of the bomb is set to 6 minutes. To prevent the bomb from exploding by shake, Ignatius had to move slowly, that is to move from one area to the nearest area(that is, if Ignatius stands on (x,y) now, he could only on (x+1,y), (x-1,y), (x,y+1), or (x,y-1) in the next minute) takes him 1 minute. Some area in the labyrinth contains a Bomb-Reset-Equipment. They could reset the exploding time to 6 minutes.

Given the layout of the labyrinth and Ignatius' start position, please tell Ignatius whether he could get out of the labyrinth, if he could, output the minimum time that he has to use to find the exit of the labyrinth, else output -1.

Here are some rules:
1. We can assume the labyrinth is a 2 array.
2. Each minute, Ignatius could only get to one of the nearest area, and he should not walk out of the border, of course he could not walk on a wall, too.
3. If Ignatius get to the exit when the exploding time turns to 0, he can't get out of the labyrinth.
4. If Ignatius get to the area which contains Bomb-Rest-Equipment when the exploding time turns to 0, he can't use the equipment to reset the bomb.
5. A Bomb-Reset-Equipment can be used as many times as you wish, if it is needed, Ignatius can get to any areas in the labyrinth as many times as you wish.
6. The time to reset the exploding time can be ignore, in other words, if Ignatius get to an area which contain Bomb-Rest-Equipment, and the exploding time is larger than 0, the exploding time would be reset to 6.
 

Input
The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.
Each test case starts with two integers N and M(1<=N,Mm=8) which indicate the size of the labyrinth. Then N lines follow, each line contains M integers. The array indicates the layout of the labyrinth.
There are five integers which indicate the different type of area in the labyrinth:
0: The area is a wall, Ignatius should not walk on it.
1: The area contains nothing, Ignatius can walk on it.
2: Ignatius' start position, Ignatius starts his escape from this position.
3: The exit of the labyrinth, Ignatius' target position.
4: The area contains a Bomb-Reset-Equipment, Ignatius can delay the exploding time by walking to these areas.
 

Output
For each test case, if Ignatius can get out of the labyrinth, you should output the minimum time he needs, else you should just output -1.
 

Sample Input
33 32 1 11 1 01 1 34 82 1 1 0 1 1 1 01 0 4 1 1 0 4 11 0 0 0 0 0 0 11 1 1 4 1 1 1 35 81 2 1 1 1 1 1 4 1 0 0 0 1 0 0 1 1 4 1 0 1 1 0 1 1 0 0 0 0 3 0 1 1 1 4 1 1 1 1 1
 

Sample Output
4-113
 

题目链接 HDU 1072

分析:

题意为一个人从起点2向终点3走,身上还有一个炸弹,6分钟后会爆炸

走到4时炸弹会重设,求炸弹不爆炸的情况下所用最少时间

刚开始用的优先队列,按走的时间从小到大排序,后来发现一个地方可以多次走过

但又不能走太多次,会超时,只好让一个地方最多访问5次,竟然让我侥幸A了

最后看了大牛的题解才知道不用优先队列,因为后面进队列的时间肯定比前面进的大

还有位置为4的只访问一次就行了

代码:

#include <cstdio>#include <queue>using namespace std;struct pos{    int x, y, Sum, Rest;  //Sum为所用的总时间,Rest为炸弹剩余时间} Now, Next;const int dir[][2] = {0,1, 0,-1, 1,0, -1,0};    //四个方向的偏移量int t, n, m;int sX, sY;int iMap[10][10];int bfs(){    queue<pos> Q;    Now.x = sX;    Now.y = sY;    Now.Sum = 0;    Now.Rest = 6;    Q.push(Now);    //起点进队列    while (!Q.empty())    {        Now = Q.front();        Q.pop();        if (iMap[Now.x][Now.y] == 3)    //终点        {            return Now.Sum;        }        if (Now.Rest == 1) continue;     //炸弹就要爆炸了        for (int i = 0; i < 4; i++)     //往四个方向走        {            int tx = Now.x + dir[i][0];            int ty = Now.y + dir[i][1];            if (tx >= 0 && tx < n && ty >= 0 && ty < m && iMap[tx][ty] != 0)            {                Next.x = tx;                Next.y = ty;                Next.Sum = Now.Sum + 1;                Next.Rest = Now.Rest - 1;                if (iMap[tx][ty] == 4)                {                    Next.Rest = 6;           //重设剩余时间                    iMap[tx][ty] = 0;       //访问一次后就不要访问了,不做无用功                }                Q.push(Next);       //新位置进队列            }        }    }    return -1;}int main(){    scanf("%d", &t);    while (t--)    {        scanf("%d%d", &n, &m);        for (int i = 0; i < n; i++)        {            for (int j = 0; j < m; j++)            {                scanf("%d", &iMap[i][j]);                if (iMap[i][j] == 2)        //起点                {                    sX = i;                    sY = j;                }            }        }        printf("%d\n", bfs());    }    return 0;}



0 0
原创粉丝点击